﻿@page "/users"
@using Syncfusion.Blazor.Grids

<PageTitle>Users</PageTitle>

<h1>Users</h1>

<div class="row">
    <div class="col mb-3">
        <a href="/users/create" class="btn btn-primary float-right">Create User</a>
    </div>
</div>
<div class="row">
    <div class="col">
        <SfGrid ID="Grid" @ref="Grid" DataSource="@Users" AllowGrouping="true" AllowSorting="true" AllowPaging="true" AllowResizing="true" AllowFiltering="true" Toolbar="@(new List<string>() { "Search", "ExcelExport", "CsvExport", "PdfExport", "ColumnChooser" })" ShowColumnChooser="true" AllowReordering="true" AllowExcelExport="true" AllowPdfExport="true">
            <GridFilterSettings Type="Syncfusion.Blazor.Grids.FilterType.Menu"></GridFilterSettings>
            <GridEvents OnToolbarClick="ToolbarClick" TValue="UserListModel"></GridEvents>
            <GridPageSettings PageCount="5" PageSizes="true"></GridPageSettings>
            <GridColumns>
                <GridColumn Field=@nameof(UserListModel.Email) HeaderText="Email"></GridColumn>
                <GridColumn Field=@nameof(UserListModel.FirstName) HeaderText="First Name" AutoFit="true"></GridColumn>
                <GridColumn Field=@nameof(UserListModel.LastName) HeaderText="Last Name" AutoFit="true"></GridColumn>
                <GridColumn Field=@nameof(UserListModel.Role) HeaderText="Role" AutoFit="true"></GridColumn>
                <GridColumn Field=@nameof(UserListModel.Active) HeaderText="Active" AutoFit="true"></GridColumn>
              
                <GridColumn AutoFit="true" TextAlign="TextAlign.Center">
                    <Template>
                        @{
                            var user = (context as UserListModel);
                            <a href="/users/@user.Id/edit"><i class="fa fa-edit"></i></a>
                        }
                    </Template>
                </GridColumn>
            </GridColumns>
        </SfGrid>
    </div>
</div>

@code {
    SfGrid<UserListModel> Grid;
    public List<UserListModel> Users { get; set; }
    protected async override Task OnInitializedAsync()
    {
        await JS.ShowLoader();
        Users = Mapper.Map<List<UserListModel>>(UserService.GetAll().ToList());
        await JS.HideLoader();
    }

    public void ToolbarClick(Syncfusion.Blazor.Navigations.ClickEventArgs args)
    {
        if (args.Item.Id == "Grid_pdfexport")
        {
            this.Grid.PdfExport();
        }
        if (args.Item.Id == "Grid_excelexport")
        {
            this.Grid.ExcelExport();
        }
        if (args.Item.Id == "Grid_csvexport")
        {
            this.Grid.CsvExport();
        }
    }
}
